package Chainmail::Report;
require Exporter;                      
require Chainmail::Config;

@ISA = qw(Exporter);
          
@EXPORT = qw(enter leave error fatal_error debug inform);


my @state = ();

sub enter
  {
    my $message = shift;
    
    debug( "entering state:\n\t$message" );

    unshift @state, $message;
  }


sub leave
  {
    my $real = shift;

    
    my $s = shift @state;
    
    if (defined $real)
      {
	if ( $s ne $real )
	  {
	    fatal_error( "leaving real state:\n $real\nbut context stack thinks it's:\n$s" );
	    return;
	  }
	debug( "context stack ok here" );
      }
    debug( "leaving state:\n\t$s" );
  }

sub debug
  {
    return if !Chainmail::Config::do_debugging();

    my $message = shift;
    print STDERR "Debug: $message\n";
  }

sub inform
  {
    my $message = shift;

    print STDERR "Message: $message\n";
  } 
    

sub error
  {
    my $message = shift;

    print STDERR "Error: $message\n";
    debug("error occurred in context (stack):" )
      if (@state && defined $state[0]); 
    
    foreach my $s (@state)
      {
	debug( "\t$s" );
      }

  }


sub fatal_error
  {
    my $message = shift;

    print STDERR "\nBombing out on fatal error!\n";
    error( $message );

    die;
  }

1;
